<script>
  const speed = 4000;
  const stats = [
    "More than 9% of the population has diabetes.",
    "422 million people are affected by diabetes worldwide.",
    "Diabetes is the 7th leading cause of death in the US.",
    "Type 2 diabetes has increased significantly in all countries and at all income levels.",
    "Diabetes cost a staggering $327 billion in 2017.",
    "Diabetes is one of the leading causes of death in the world."
  ];

  let curr = stats[0];

  let index = 0;
  const startLoop = () => {
    return setInterval(() => {
      index = index + 1 >= stats.length ? 0 : index + 1;
      updateStat();
    }, speed);
  };

  let loop = startLoop();

  const updateStat = () => {
    const stat = document.querySelector(".stat");
    const active = document.querySelector(".active");

    active.classList.remove("active");
    active.parentNode.children[index].classList.add("active");

    stat.style.opacity = 0;
    setTimeout(() => {
      curr = stats[index];

      stat.style.opacity = 1;
    }, 500);
  };

  const manual = e => {
    const newIndex = e.target.dataset.index;
    const active = e.target.parentNode.querySelector(".active");

    if (newIndex != active.dataset.index) {
      index = parseInt(newIndex);
      updateStat();
      clearInterval(loop);
      loop = startLoop();
    }
  };
</script>

<style>
  section {
    text-align: center;
    padding: 0 20px;
  }
  .stat {
    transition: opacity 500ms;
    min-height: 92px;
    display: flex;
    flex-flow: column nowrap;
    justify-content: center;
    align-items: center;
    margin: auto;
  }
  @media (max-width: 570px) {
    .stat {
      min-height: 128px;
    }
  }
  @media (max-width: 430px) {
    .stat {
      min-height: 164px;
    }
  }
  @media (max-width: 353px) {
    .stat {
      min-height: 200px;
    }
  }
  .title {
    font-size: 24px;
    color: #fff;
    margin: 0 0 20px;
  }
  h2 {
    color: var(--primary);
    font-size: 30px;
    margin: 0 0 20px;
  }
  ol {
    display: flex;
    flex-flow: row nowrap;
    justify-content: center;
    align-items: center;

    padding: 0;
    margin: 0;
  }
  li {
    display: block;
    cursor: pointer;
    color: var(--primary);
    user-select: none;
    font-size: 16px;
  }

  li::before {
    content: "";
    display: inline-block;
    width: 10px;
    height: 10px;
    border-radius: 50%;
    border: 1px solid var(--primary);
    margin-left: 5px;
    transition: background 200ms;
  }

  li.active::before {
    background: var(--primary);
  }

  li:not(.active)::before {
    background: transparent;
  }

  .source {
    font-size: small;
  }
</style>

<section>
  <div class="stat">
    <p class="title">{curr}</p>
  </div>

  <h2>It Is Preventable</h2>

  <ol class="controls">
    {#each stats as s, i}
      <li on:click={manual} class={i == 0 ? 'active' : ''} data-index={i} />
    {/each}
  </ol>

  <p class="source">Statistics from the WHO and CDC.</p>
</section>
